/******************************************************************************************/
/***************************    0. Head Files needed     **********************************/
/******************************************************************************************/
#define WIN32_LEAN_AND_MEAN		
#include <cstdlib>
#include <cstdlib>
#include "stdio.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <sstream>
#include <fstream>
#include <string.h>
#include <time.h>
#include <ctime>
#include <vector>
#include <math.h>
#include <ctype.h>
#include <vector>
using namespace std;
/******************************************************************************************/
/********************    1. Data Structure and Global Variables    ************************/
/******************************************************************************************/
typedef struct Solution{
	int *p ;
	int *SizeG; 
	int ** XG; 
	double cost ;
}Solution ; 

char * File_Name;
char * Output_File_Name;
char * Solution_File;

int N, K;  // node number and group number
double f, f_best; 
Solution CS, NS, GS, OS;  
double total_time, starting_time, Time_limit;
int * p; // patition array for each vertex
int * bestp ; // patition array for each vertex 
int * SizeG ; 
double ** Delta_Matrix;  // incremental matrix 
double ** Delta_Matrix1; 
double ** Delta; 
double ** Delta1; 
double ** D;   // distance matrix between elements
double ** DT;
int **Tabutenure;
int * LB; // Lower bound of the number of elements in the group i 
int * UB; // Upper bound of the number of elements in the group i 
int ** state1;
int ** state2;
double beta = 0.1;
/******************************************************************************************/
/********************    2. Inputing Data and Assign Memeries   ***************************/
/******************************************************************************************/
void inputing()
{
    int i,j,k; 
    int x1, x2;
    float d;
	ifstream FIC;
	FIC.open(File_Name);
	if ( FIC.fail() )
	{
		cout << "### Erreur open, File_Name " << File_Name << endl;
		exit(0);
	}
	FIC >> N >> K;
	char StrReading[100];
	FIC >> StrReading;
	if ( FIC.eof() )
	{
		cout << "### Error open, File_Name " << File_Name << endl;
		exit(0);
	}	
	if ( strcmp(StrReading, "ds" )==0 || strcmp(StrReading, "ss" )==0 )
	{
         LB = new int [K];
         UB = new int [K]; 
         for(i=0;i<K;i++) { FIC >> LB[i]; FIC >> UB[i];}
    }
    
    D = new double * [N];
    for(i=0;i<N;i++) D[i] = new double [N];
    for(i=0;i<N;i++)
      for(j=0;j<N;j++) D[i][j] = 0.0;  
      
    DT = new double * [N];
    for(i=0;i<N;i++) DT[i] = new double [N]; 
    
    for(i=0;i<N;i++)
      for(j=0;j<N;j++) DT[i][j] = 0.0; 
  
	while ( ! FIC.eof() )
	{
			FIC >> x1 >> x2 >> d;
			//cout << x1 <<"  "<< x2 <<"  "<<d<<" "<< endl;
			if ( x1<0 || x2<0 || x1>=N || x2 >=N )
			{
				cout << "### Error of node : x1="
					<< x1 << ", x2=" << x2 << endl;
				exit(0);
			}
			if(x1 != x2)
			{
				
                D[x2][x1] = d; 
                D[x1][x2] = D[x2][x1] ;
                
                DT[x2][x1] = 2.0*d;
                DT[x1][x2] = DT[x2][x1] ;
			}
	
     } 
     FIC.close();
 }

void AssignMemery()
{
    int i,j;  
	
    p = new int [N];
    bestp = new int [N];
    SizeG = new int [K];
	
    Delta_Matrix = new double *[N];
       for(i=0;i<N;i++) Delta_Matrix[i] = new double [K]; 
    Delta_Matrix1 = new double *[N];
       for(i=0;i<N;i++) Delta_Matrix1[i] = new double [K];    
       
    Delta = new double *[N];
       for(i=0;i<N;i++) Delta[i] = new double [K];  
       
    Delta1 = new double *[N];
       for(i=0;i<N;i++) Delta1[i] = new double [K];      
       
    Tabutenure = new int *[N];
     for(i=0;i<N;i++) Tabutenure[i] = new int [K]; 
    
	CS.p = new int [N];
	NS.p = new int [N];
	GS.p = new int [N]; 
	OS.p = new int [N]; 
    
	CS.SizeG = new int [K];
	NS.SizeG = new int [K];
	GS.SizeG = new int [K];
	OS.SizeG = new int [K];
	
	 CS.XG = new int *[K]; 
    for(i=0;i<K;i++)
    {
		CS.XG[i] = new int [N] ; 
	}
    
    NS.XG = new int *[K]; 
    for(i=0;i<K;i++)
    {
		NS.XG[i] = new int [N] ; 
	}
    
    GS.XG = new int *[K]; 
    for(i=0;i<K;i++)
    { 
		GS.XG[i] = new int [N] ; 
	}
    
    OS.XG = new int *[K]; 
    for(i=0;i<K;i++)
    {
		OS.XG[i] = new int [N];  
	}
	  
	state1 = new int *[K];
	for(i=0;i<K;i++) state1[i] = new int [K]; 
	
    state2 = new int *[K];
	for(i=0;i<K;i++) state2[i] = new int [K]; 
}

void ReleaseMemery()
{    
     int i;
	 
     delete [] p; p = NULL;
	 delete [] bestp; bestp = NULL; 
	 delete [] SizeG; SizeG = NULL; 
	 
	 delete [] CS.p; CS.p = NULL;
	 delete [] CS.SizeG; CS.SizeG = NULL; 
	 delete [] GS.p; GS.p = NULL;
	 delete [] GS.SizeG; GS.SizeG = NULL; 
	 delete [] NS.p; NS.p = NULL;
	 delete [] NS.SizeG; NS.SizeG = NULL; 
	 delete [] OS.p; OS.p = NULL;
	 delete [] OS.SizeG; OS.SizeG = NULL; 
	 
	 delete [] LB; LB = NULL; 
	 delete [] UB; UB = NULL; 
	 
	 for(i=0;i<N;i++)
	 { 
	   delete [] Delta_Matrix[i]; Delta_Matrix[i] = NULL ;
       delete [] Delta_Matrix1[i]; Delta_Matrix1[i] = NULL ;
       delete [] Delta[i]; Delta[i] = NULL ;
       delete [] Delta1[i]; Delta1[i] = NULL ;
	   delete [] D[i]; D[i] = NULL; 
       delete [] DT[i]; DT[i] = NULL; 
	 }
}

/******************************************************************************************/
/*********************************    3. OutPuting Results   ******************************/
/******************************************************************************************/
int Proof(Solution &S)
{   
    int i,j;
    double ff;
    int flag ;
    ff = 0.0;
    for( i = 0 ; i < N ; i++ )  
	   for( j = i+1 ; j < N ; j++ )
	      {
	          if(S.p[i] == S.p[j])
               {   	
				  ff += D[i][j];
	           }
	      }
    S.cost = ff; 
    for(i=0;i<K;i++) S.SizeG[i] = 0; 
    for(i=0;i<N;i++) S.SizeG[S.p[i]]++; 
    flag = 1; 
    for(i=0; i < K; i++) 
    if(S.SizeG[i] < LB[i]|| S.SizeG[i]> UB[i]) { flag = 0; break;} 
  //  printf(" %d   ********** \n",flag);
    return flag;  
}

void Outputing(Solution &S, char *filename)
{
    int i;int r;
	FILE *fp; 
	char buff[80];
	r= rand()%1000;
	if(Proof(S)==0) return;
    sprintf(buff,"%s",filename);
    fp=fopen(buff,"a+");
    fprintf(fp,"N = %d  G = %d  f = %lf\n", N , K, S.cost); 
    for(i=0;i<K;i++)
    fprintf(fp,"%5.2d   %5.2d   %5.2d \n", LB[i], UB[i], S.SizeG[i]); 
    printf("\n");
    for(i=0;i<N;i++)
    fprintf(fp,"%5.3d   %5.2d\n",i, S.p[i]); 
	fclose(fp);
}

void Out_results(double best , double ave,  double worst, char *filename, char instance[])
{
    int i;
	FILE *fp; 
	char buff[80];
    sprintf(buff,"%s",filename);
    fp = fopen(buff,"a+");
    fprintf(fp,"%s   %lf   %lf   %lf\n", instance, best, ave, worst); 
	fclose(fp);
}

/******************************************************************************************/
/****************   4. Constructive Heuristics for Initial Solution   *********************/
/******************************************************************************************/
void RandomInitiaSol(Solution &S)
{    
    
     int i,j;
     int p1;
     int count;
     int tot_number;
     int sum=0;
     int *Flag;
     int *SizeGroup; 
     SizeGroup = new int [K];
     for(i=0;i<K;i++) SizeGroup[i] = 0;
     Flag = new int [N];
     for(i=0; i<N; i++) Flag[i] = 0;
     for(i=0; i < K; i++) sum += LB[i]; 
     tot_number=0; 
     while(tot_number < sum)
     {
        p1 = rand()%N;
        if(Flag[p1]==0)
        {
           count=0;
           while(count<K)
           {  
              if(SizeGroup[count] < LB[count])
              { 
                S.p[p1] = count; 
                S.XG[count][SizeGroup[count]] = p1; 
                Flag[p1] = 1; 
                SizeGroup[count]++; 
                tot_number++;
                break;
              }
              else count++;
           }
        }
     
     }
     
     tot_number=0; 
     while(tot_number < N - sum)
     {
        p1 = rand()%N;
        if(Flag[p1]==0)
        {
          
           while(1)
           {  
              count = rand()%K; 
              if(SizeGroup[count] < UB[count])
              { 
                S.p[p1] = count; 
                S.XG[count][SizeGroup[count]] = p1; 
                Flag[p1] = 1; 
                SizeGroup[count]++; 
                tot_number++;
                break;
              }
              
           }
        }
     
     } 

     for(i=0;i<K;i++)  S.SizeG[i] = SizeGroup[i];
     delete [] SizeGroup; SizeGroup= NULL;
     delete [] Flag; Flag = NULL; 
}

void GreedyInitiaSol(Solution &S)
{    
    
     int i,j,g;
     int r, g_max;
     int count, start_index, cur_index;
     int tot_number;
     int sum = 0;
     int *Flag;
     double *SumG, MaxSumG; 
     
     SumG = new double [K]; 
     for(g=0;g<K;g++) S.SizeG[g] = 0;
     Flag = new int [N];
     for(i=0;i<N;i++) Flag[i] = 0;
     
     //a. assign randomly K elements to K distinct groups
     for(g=0;g<K;g++)
     {
         while(1)
         {
             r = rand()%N;
             if(Flag[r]==0)
             {
                S.p[r] = g;
                S.XG[g][S.SizeG[g]] = r; 
                Flag[r] = 1; 
                S.SizeG[g]++;
                break; 
             }
         }
     }
  
     //b. assign greedyly the elements to satisfy the lower bound constraints of groups 
     for(g = 0; g < K; g++) sum += LB[g];
     tot_number = K; 
     while(tot_number < sum)
     {  
        
        cur_index = rand()%N; 
        do
        {
           cur_index = (cur_index + 1)%N;           
        }while(Flag[cur_index]); 
        
        for(g=0;g<K;g++) SumG[g] = 0.0;
        
        for(j=0;j<N;j++)
           if(Flag[j]==1) SumG[S.p[j]] += D[cur_index][j];
        for(g=0;g<K;g++) SumG[g] /= S.SizeG[g];
        
        MaxSumG = -9999.0; 
        for(g=0; g<K; g++)
         if(S.SizeG[g] < LB[g] && SumG[g] > MaxSumG)
         {
            MaxSumG = SumG[g];
            g_max = g; 
         }
        
        S.p[cur_index] = g_max;
        S.XG[g_max][S.SizeG[g_max]] = cur_index; 
        Flag[cur_index] = 1;
        S.SizeG[g_max]++; 
        
        tot_number++;
     }
     //c. assign the remaining the elements 
     tot_number=0; 
     while(tot_number < N - sum)
     {
        cur_index = rand()%N; 
        do
        {
          cur_index = (cur_index + 1)%N;           
        }while(Flag[cur_index]); 
        
        for(g=0; g<K; g++) SumG[g] = 0.0; 
        
        for(j=0;j<N;j++)
           if(Flag[j]==1) SumG[S.p[j]] += D[cur_index][j];
        for(g=0;g<K;g++) SumG[g] /= S.SizeG[g];
        
        MaxSumG = -9999.0; 
        for(g=0; g<K; g++)
         if(S.SizeG[g] < UB[g] && SumG[g] > MaxSumG)
         {
            MaxSumG = SumG[g];
            g_max = g; 
         } 
        
        S.p[cur_index] = g_max;
        S.XG[g_max][S.SizeG[g_max]] = cur_index; 
        Flag[cur_index] = 1;
        S.SizeG[g_max]++; 
        tot_number++;
    }    
    delete [] Flag; Flag = NULL; 
    delete [] SumG; SumG = NULL;    
}

double distance1(int S1[], int S2[]) 
{
    int i,j; 
    int Ecount; 
    double dist;
    Ecount = 0; 
    for(i=0;i<N;i++)
      for(j=i+1;j<N;j++)
        if( (S1[i] == S1[j] && S2[i] != S2[j])  ||  (S1[i] != S1[j] && S2[i] == S2[j]) ) Ecount++;   
    dist = 1.0*(Ecount*K)/(1.0*N*N);  
    //printf("Dist =%d  dis = %lf \n",Ecount, dist); 
    return dist; 
} 

double distance(int S1[], int S2[]) 
{
    int i,j; 
    int Ecount, Ecount1; 
    double dist;
    Ecount = 0; Ecount1 = 0; 
    for(i=0;i<N;i++)
      for(j=i+1;j<N;j++)
		{
		  if( (S1[i] == S1[j] && S2[i] != S2[j])  ||  (S1[i] != S1[j] && S2[i] == S2[j]) ) Ecount++;   
		  if(S1[i]==S1[j] || S2[i] == S2[j]) Ecount1++;  
    	}
    //dist = 1.0*(Ecount*K)/(1.0*N*N);  
    dist = (double) Ecount/Ecount1; 
    //printf("Dist =%d  dis = %lf \n",Ecount, dist); 
    return dist; 
} 

/******************************************************************************************/
/*******************************    5. Local Search Method   ******************************/
/******************************************************************************************/
//2.1 Clear delta matrix
void Clear_Delta_Matrix( )
{
	int x, g, i, j;
	for( x = 0 ; x < N ; x++)
	  for( g = 0 ; g < K ; g++ )
		  Delta_Matrix[ x ][ g ] = 0.0 ; 	
		  
	for( x = 0 ; x < N ; x++ )
	   for( g = 0 ; g < K ; g ++ )
            Tabutenure[ x ][ g ] = 0 ;	  	  
		  
	for(i=0;i<K;i++)
	{
	   for(j=0;j<K;j++) 
	   {
	   	 state1[i][j] = 0;
		 state2[i][j] = 0; 
	   } 
    }
	for(i=0;i<K;i++)
	{
	   state1[i][i] = 1;
	   state2[i][i] = 1;
	}	  	
}

//2.2 Build delta matrix
void Build_Delta_Matrix()
{
	int i,j;
	Clear_Delta_Matrix( );
	for(i = 0; i < N ; i++ )
	   for( j = 0 ; j < N ; j++ )
	     {  
		     Delta_Matrix[ i ][ p[j] ]  +=  D[i][j];
	     }
		 
	for(i = 0; i < N ; i++ )
	   for( j = 0 ; j < K ; j++ )
         Delta[i][j] = Delta_Matrix[ i ][ j ] - Delta_Matrix[ i ][ p[i] ];
       
    f = 0.0;
    for( i = 0 ; i < N ; i++ )
      f += Delta_Matrix[i][p[i]];
    f = f/2;  
                    
	//printf("\n f= %lf ********** \n", f);
    //return ;
}

//2.2 Update one move delta matrix
void One_Move_Update_Delta_Matrix(int i, int g0, int g1)
{
    int x,j,k;
    
    for(j=0;j<N;j++)
     {  
           if(j!=i)
           {
             Delta_Matrix[ j ][ g0 ] -= D[i][j];
             Delta_Matrix[ j ][ g1 ] += D[i][j];
           } 
     }         
     
    for(x=0; x<N; x++)
     {  
         if(x!=i)
           {
               Delta[x][g0] =   Delta_Matrix[ x ][ g0 ] - Delta_Matrix[ x ][ p[ x ] ];
               Delta[x][g1] =   Delta_Matrix[ x ][ g1 ] - Delta_Matrix[ x ][ p[ x ] ]; 
                
               if(p[x]==g0)
               {
                 for(k=0;k<K;k++)
                  { 
                     Delta[x][k] =  Delta_Matrix[ x ][ k ] - Delta_Matrix[ x ][ g0 ]; 
                  }               
               }
               
               if(p[x]==g1)
               { 
                 for(k=0;k<K;k++) 
                 {
                    Delta[x][k]=  Delta_Matrix[ x ][ k ] - Delta_Matrix[ x ][ g1 ];
                 } 
               }
               
           }   
     } 
     
    x = i;
    for(k=0; k<K; k++) Delta[x][k] = Delta_Matrix[ x ][ k ] - Delta_Matrix[ x ][ g1 ];  
                                                    
//	return ;
}
void One_Move_Update_Delta_Matrix1(int i, int g0, int g1)
{
    int x,j,k;
    
    for(j=0;j<N;j++)
     {  
           if(j!=i)
           {
             Delta_Matrix[ j ][ g0 ] -= D[i][j];
             Delta_Matrix[ j ][ g1 ] += D[i][j];
           } 
     }                                                         
	return ;     
}

int LSN1(Solution &S) 
{
	 int i, j, v, swap; 
	 int g1, g2, flag, Flag;  
	 int gi, gj; 
     double delt, ff;  
     
     Flag = 0; 
	 ff = S.cost;
	 g1 = rand()%K; 
	 for(gi = 0; gi < K; gi++)
	  {
	  	g1++;
	  	if(g1==K) g1 = 0; 
	  	g2= rand()%K;
	    for(gj = 0; gj < K; gj++)
	    {
	        g2++;
	        if(g2==K) g2 = 0; 
	    	if(g1 == g2 || state1[g1][g2] == 1 || S.SizeG[g2] >= UB[g2] || S.SizeG[g1] <= LB[g1]) continue;
		   	//if(g1 == g2 || S.SizeG[g2] >= UB[g2] || S.SizeG[g1] <= LB[g1]) continue;
	    	state1[g1][g2] = 1; 
	    		
	    	flag = 0; 
	    	for(i = 0; i < S.SizeG[g1]; i++)
	    	{
	    		if(i >= S.SizeG[g1]) continue;
	    		
				v = S.XG[g1][i]; 
	    		if(  ( S.SizeG[ g1 ] > LB[ g1 ] )  && ( S.SizeG[g2]  < UB[g2] )  )
	    		{
	    		   	delt = Delta_Matrix[ v ][ g2 ] - Delta_Matrix[ v ][ g1 ];  
                    if(delt > 1.0e-10) 
                    {               
				      One_Move_Update_Delta_Matrix1(v, g1, g2); 
					  S.XG[g2][S.SizeG[g2]] = v; 
					  swap = S.XG[g1][i]; 
					  S.XG[g1][i] = S.XG[g1][S.SizeG[g1]-1];  
					  S.XG[g1][S.SizeG[g1]-1] = swap;  
				      S.p[v] = g2; 	
				      
				      S.SizeG[g1] = S.SizeG[g1] - 1; 
                      S.SizeG[g2] = S.SizeG[g2] + 1; 
                      
			  	      flag = 1; 
			  	      Flag = 1; 
			  	      ff += delt; 
			  	      i--;  
                    }
				}	
			}
			if(flag)
			{
				//a. update state1
				for(i=0;i<K;i++) 
				  if(i == g1) continue; 
				  else 
				  {
				    state1[i][g1] = 0; 
				    state1[g1][i] = 0; 
				  }
				for(j=0;j<K;j++) 
				  if(j==g2) continue; 
				  else 
				  {
				    state1[j][g2] = 0;
				    state1[g2][j] = 0;
			      }
			    //b. update state2
			    for(i=0;i<K;i++)
			      if(i==g1) continue; 
			      else
			      {
			      	state2[i][g1] = 0; 
				    state2[g1][i] = 0;  
				  }
			    for(j=0;j<K;j++) 
			      if(j==g2) continue; 
			      else
			      {
			      	 state2[j][g2] = 0; 
			      	 state2[g2][j] = 0; 
				  }
			}
		}
      }
      
	 S.cost = ff; 
	 return Flag; 
}

int LSN21(Solution &S)
{
	 int i, j, v, u, swap;
	 int g1, g2, flag, FLAG; 
	 int gi,gj; 
     double delt, ff; 
     
	 ff = S.cost;
	 FLAG = 0; 
	 flag = 0; 
	 g1 = rand()%K; 
	 for(gi = 0; gi < K; gi++)
	  {
	   g1 ++; 
	   if(g1==K) g1 = 0; 
	   g2 = rand()%K;
	   for(gj = 0 ; gj < K; gj++)
	    {
	    	g2 ++; 
	    	if(g2==K) g2 = 0; 
	    	
			if(g1 == g2 || state2[g1][g2] == 1) continue;  
	    	state2[g1][g2] = 1;  
	    	state2[g2][g1] = 1;   
	    	
	    	flag = 0;  
	    	for(i = 0; i < S.SizeG[g1]; i++) 
   	  	    for(j = 0; j < S.SizeG[g2]; j++)
	    	  {
				    v = S.XG[g1][i];  
				    u = S.XG[g2][j];  
	    		   	delt =  (Delta_Matrix[ v ][ g2 ] - Delta_Matrix[ v ][ g1 ]) + (Delta_Matrix[ u ][ g1 ] - Delta_Matrix[ u ][ g2 ]) - DT[v][u];
                    if(delt > 1.0e-10) 
                    {               
				      
					  One_Move_Update_Delta_Matrix1(v, g1, g2); 
				      One_Move_Update_Delta_Matrix1(u, g2, g1); 
				      
					  swap = S.XG[g1][i]; 
					  S.XG[g1][i] = S.XG[g2][j];  
					  S.XG[g2][j] = swap;  
					  
				      S.p[v] = g2; 	
					  S.p[u] = g1; 
					 
			  	      flag = 1; 
			  	      FLAG = 1;
			  	      ff += delt; 
                    }
					
		      }
		      
			if(flag)
			{
				//a. update state1
				for(i=0;i<K;i++) 
				  if(i == g1) continue; 
				  else 
				  {
				    state1[i][g1] = 0; 
				    state1[g1][i] = 0; 
				  }
				for(j=0;j<K;j++) 
				  if(j==g2) continue; 
				  else 
				  {
				    state1[j][g2] = 0;
				    state1[g2][j] = 0;
			      }
			    //b. update state2
			    for(i=0;i<K;i++)
			      if(i==g1) continue; 
			      else
			      {
			      	state2[i][g1] = 0; 
				    state2[g1][i] = 0;  
				  }
			    for(j=0;j<K;j++) 
			      if(j==g2) continue; 
			      else
			      {
			      	 state2[j][g2] = 0; 
			      	 state2[g2][j] = 0; 
				  }
				//goto label; 
			}
		}
		
      }
	// label: 	
	 S.cost = ff; 	
	return FLAG;  
}
int LSN2(Solution &S)
{
	 int i, j, v, u, swap, swap1;
	 int g1, g2, flag, FLAG, r1, r2; 
	 int C1, C2; 
     double delt, ff; 
     int *SI;
	 int *SJ; 
	 
     SI = new int [K];
     SJ = new int [K]; 
     
     for(i=0;i<K;i++) 
     {
	    SI[i] = i; 
	    SJ[i] = i; 
     }
     
	 ff = S.cost;
	 FLAG = 0; 
	 flag = 0; 
	 
	 C1 = K;
	 while(C1 > 0)
	  {
	    r1 = rand()%C1; 
	    g1 = SI[r1]; 
	    swap1 = SI[r1];
	    SI[r1] = SI[C1-1];
	    SI[C1-1] = swap1; 
	    C1--;
	    
	    C2 = K; 
	    for(i=0;i<K;i++)  SJ[i] = i; 
     
	    while(C2 > 0)
	    {
	        r2 = rand()%C2;
			g2 = SJ[r2];
			swap1 = SJ[r2];
			SJ[r2] = SJ[C2-1];
			SJ[C2-1] = swap1;  
	    	C2--;
    		if(g1 == g2 || state2[g1][g2] == 1) continue;
	    	state2[g1][g2] = 1;  
	    	state2[g2][g1] = 1;   
	    	
	    	flag = 0;  
	    	for(i = 0; i < S.SizeG[g1]; i++) 
   	        for(j = 0; j < S.SizeG[g2]; j++)
	    	  {
				    v = S.XG[g1][i];  
				    u = S.XG[g2][j];  
	    		   	delt =  (Delta_Matrix[ v ][ g2 ] - Delta_Matrix[ v ][ g1 ]) + (Delta_Matrix[ u ][ g1 ] - Delta_Matrix[ u ][ g2 ]) - DT[v][u];
                    if(delt > 1.0e-10) 
                    {               
				      
					  One_Move_Update_Delta_Matrix1(v, g1, g2); 
				      One_Move_Update_Delta_Matrix1(u, g2, g1); 
				      
					  swap = S.XG[g1][i]; 
					  S.XG[g1][i] = S.XG[g2][j];  
					  S.XG[g2][j] = swap;  
					  
				      S.p[v] = g2; 	
					  S.p[u] = g1; 
					 
			  	      flag = 1; 
			  	      FLAG = 1;
			  	      ff += delt; 
                    }
					
		      }
		      
			if(flag)
			{
				//a. update state1
				for(i=0;i<K;i++) 
				  if(i == g1) continue; 
				  else 
				  {
				    state1[i][g1] = 0; 
				    state1[g1][i] = 0; 
				  }
				for(j=0;j<K;j++) 
				  if(j==g2) continue; 
				  else 
				  {
				    state1[j][g2] = 0;
				    state1[g2][j] = 0;
			      }
			    //b. update state2
			    for(i=0;i<K;i++)
			      if(i==g1) continue; 
			      else
			      {
			      	state2[i][g1] = 0; 
				    state2[g1][i] = 0;  
				  }
			    for(j=0;j<K;j++) 
			      if(j==g2) continue; 
			      else
			      {
			      	 state2[j][g2] = 0; 
			      	 state2[g2][j] = 0; 
				  }
			
			}
			
		}
	   	
      }
 	
	 S.cost = ff; 	
//	 for(i=0;i<K;i++)
//	 printf("%d  ",SJ[i]); printf("!!\n");
//	 printf("%d   %d\n",C1,C2);
	 delete [] SI;
	 delete [] SJ; 
 	 return FLAG;  
}

void LocalSearch(Solution &S)
{
	 int i,rez1,rez2;
     for(i=0;i<N;i++) p[i] = S.p[i];
     Build_Delta_Matrix(); 
     S.cost = f;     
     do
     {
        rez1  = LSN1(S);
        rez2  = LSN2(S); 
      //  printf("%lf\n",S.cost); 
     } while(rez1||rez2);
     
}

/******************************************************************************************/
/**********************  7. Strong Perturbation Operators     *****************************/
/******************************************************************************************/
void Shake(Solution &S, int theta)
{
    int g1,g2, x, y, r1, r2;
    int swap ;
    int count = 0; 
    
    do
	{     
             g1 =  rand()%K; 
             g2 =  rand()%K; 
             r1 = rand()%S.SizeG[g1]; 
             r2 = rand()%S.SizeG[g2]; 
             
             x = S.XG[g1][r1];
             y = S.XG[g2][r2]; 
             
             if(S.p[x] != S.p[y]) 
             {     	
				swap   = S.p[ x ];
				S.p[ x ] = S.p[ y ];  
				S.p[ y ] = swap; 
				
			    swap = S.XG[g1][r1]; 
			    S.XG[g1][r1] = S.XG[g2][r2] ;
			    S.XG[g2][r2] = swap; 
			    
				count ++; 
             }      
            	                            
    } while(count < theta);  
    
 }

/******************************************************************************************/
/***********************************    8. Initial solution    ****************************/
/******************************************************************************************/
void InitialSol(Solution &S)
{
     int i,j; 
     int counter=0;
     GS.cost = -99999;
     GreedyInitiaSol(S); 
     LocalSearch(S);
     counter++;
     while(counter < 10)
     {
        GreedyInitiaSol(NS); 
        LocalSearch(NS);
        if(NS.cost > S.cost)
        {
           for(i=0;i<N;i++) S.p[i] = NS.p[i];
           for(j=0;j<K;j++) S.SizeG[j] = NS.SizeG[j];
           for(i=0;i<K;i++) 
 	          for(j = 0;j < S.SizeG[i];j ++) S.XG[i][j] = NS.XG[i][j];
           S.cost = NS.cost;
        }
       counter++;  
     }
}

/******************************************************************************************/
/***************************      9. Tabu Search Method         **************************/
/******************************************************************************************/
double Swap_Move_Tabu_Search(Solution &S)
{
	int i, j, v; 
	int non_improve = 0 ;  // the stop condition of TS
	int num_tabu_best, num_best ;  // the number of tabu neighbors and non-tabu neighbors
	int x, y, g, g1, g2;
	int best_x[ 50 ], best_y[ 50 ], best_posit_x[50], best_posit_y[50]; 
	int tabu_best_x[ 50 ], tabu_best_y[ 50 ], tabu_best_posit_x[50], tabu_best_posit_y[50];
	int iter; 
	double tabu_best_delta, best_delta, delt ;
	int old_group, old_group1;
	int select ; 
    int num; 
   	int swap;  
   	
	double total_time = 0.0, starting_time = 0.0;

	for(i=0;i<N;i++) p[i] = S.p[i];
	starting_time = clock();
	Build_Delta_Matrix();
	f_best = f ; 

//	printf("\n\n");
//	cout << endl << "Swap_Move :       iter       f       f_best      time " << endl;
//	cout << "---------------------------------------------------" << endl; 
    for(i=0;i<K;i++) SizeG[ i ] = S.SizeG[i];
    for(i=0;i<N;i++) bestp[ i ] = S.p[i]; 
	iter = 0 ; 
	while( non_improve < 500)
	{
		tabu_best_delta = -99999 ; 
		best_delta = -99999 ;
		num_tabu_best = 0 ; 
		num_best = 0 ;	

		for(g1 = 0 ; g1 < K ; g1 ++)
            for(g2 = g1+1 ; g2 < K ; g2 ++)
			   if( state2[g1][g2] == 0 || ( state2[g1][g2]==1 && (double) rand()/RAND_MAX < 0.05))
                {   
                    state2[g1][g2] = 1; 
                    state2[g2][g1] = 1;
	    	        for(i = 0; i < S.SizeG[g1]; i++) 
	    	          for(j = 0; j < S.SizeG[g2]; j++)   
					   {
					    x = S.XG[g1][i];  
				        y = S.XG[g2][j];   
						delt = (Delta_Matrix[ x ][S.p[y]] - Delta_Matrix[ x ][ S.p[ x ] ]) + (Delta_Matrix[ y ][S.p[x]] - Delta_Matrix[ y ][ S.p[ y ]]) - (2.0*D[x][y]);
						if( (Tabutenure[ x ][ S.p[y] ] <= iter) && (Tabutenure[ y ][ S.p[x] ] <= iter) ) // if this is not tabued 
                        {
							if( delt > best_delta )
							{
								best_x[ 0 ]     = x ; 
								best_posit_x[0] = i; 
								best_y[ 0 ]     = y ;
								best_posit_y[0] = j; 
								best_delta = delt ; 
								num_best = 1 ;
							}
							else if( delt == best_delta && num_best < 50 )
							{
								best_x[ num_best ] = x ; 
								best_posit_x[num_best] = i; 
								best_y[ num_best ] = y ;
								best_posit_y[num_best] = j; 
								num_best ++ ;
							}
						}                                                    
						else if( (Tabutenure[ x ][ S.p[y] ] > iter) || (Tabutenure[ y ][ S.p[x] ] > iter))// if it is tabu 
						{ 
							if( delt > tabu_best_delta  )
							{
								tabu_best_x[ 0 ] = x ; 
								tabu_best_posit_x[0] = i;
								tabu_best_y[ 0 ] = y ; 
								tabu_best_posit_y[0] = j; 
								tabu_best_delta = delt ; 
								num_tabu_best = 1 ;
							}
							else if( delt == tabu_best_delta && num_tabu_best < 50 )
							{
								tabu_best_x[ num_tabu_best ] = x ; 
								tabu_best_posit_x[ num_tabu_best ] = i;
								tabu_best_y[ num_tabu_best ] = y ; 
								tabu_best_posit_y[ num_tabu_best ] = j; 
								num_tabu_best ++ ; 
							}                               
						}
		                if( f + delt > f_best + 0.00001)  goto label;
				   }
		    	}
	        
			//choose the tabu best move if the tab aspiration criterion is satisfied
			label: 
			if( ( num_tabu_best > 0 && tabu_best_delta > best_delta && ( f + tabu_best_delta > f_best ) ) || (num_best == 0) )  // aspiration criterion 
			{
				f += tabu_best_delta ;
				select = rand( ) % num_tabu_best ;  
                 
                old_group  = S.p[ tabu_best_x[ select ] ]; 
                old_group1 = S.p[ tabu_best_y[ select ] ] ;  
                          
				One_Move_Update_Delta_Matrix1( tabu_best_x[ select ], old_group,  S.p[ tabu_best_y[ select ]]);
				One_Move_Update_Delta_Matrix1( tabu_best_y[ select ], old_group1, S.p[ tabu_best_x[ select ]]);
					
				swap = S.p[ tabu_best_x[ select ]] ; 
				S.p[ tabu_best_x[ select ] ] = S.p[tabu_best_y[ select ]];
				S.p[tabu_best_y[ select ]] = swap;
				
				swap = S.XG[old_group][tabu_best_posit_x[select]];
				S.XG[old_group][tabu_best_posit_x[select]]  =  S.XG[old_group1][tabu_best_posit_y[select]];
				S.XG[old_group1][tabu_best_posit_y[select]] =  swap; 
				
				Tabutenure[ tabu_best_x[ select ] ][ old_group ]  =   15  + rand()%6 ; 
				Tabutenure[ tabu_best_x[ select ] ][ old_group ]  +=  iter ; 
                            
				Tabutenure[ tabu_best_y[ select ] ][ old_group1 ] =   15  + rand()%6 ; 
				Tabutenure[ tabu_best_y[ select ] ][ old_group1 ] +=  iter ;
						
				for(i=0;i<K;i++)
			      if(i!=old_group)
			      {
			      	state2[i][old_group] = 0; 
				    state2[old_group][i] = 0;  
				  }
				  
			    for(j=0;j<K;j++) 
			      if(j!=old_group1)
			      {
			      	 state2[j][old_group1] = 0; 
			      	 state2[old_group1][j] = 0; 
				  }
	    	} 
	    	
			else //choose the best non tabu move
			{
				f += best_delta ; 
				select = rand( ) % num_best ;  
        
       		    old_group  = S.p[ best_x[ select ] ]; 
                old_group1 = S.p[ best_y[ select ] ] ;  
                          
				One_Move_Update_Delta_Matrix1( best_x[ select ], old_group,  S.p[ best_y[ select ]]);
				One_Move_Update_Delta_Matrix1( best_y[ select ], old_group1, S.p[ best_x[ select ]]);
					
				swap = S.p[ best_x[ select ]] ;
				S.p[ best_x[ select ] ] = S.p[best_y[ select ]];
				S.p[best_y[ select ]] = swap;
				
				swap = S.XG[old_group][best_posit_x[select]];
				S.XG[old_group][best_posit_x[select]]  =  S.XG[old_group1][best_posit_y[select]];
				S.XG[old_group1][best_posit_y[select]] =  swap; 
				
				Tabutenure[ best_x[ select ] ][ old_group ]  =  15  + rand()%6; 
				Tabutenure[ best_x[ select ] ][ old_group ]  += iter ; 
                            
				Tabutenure[ best_y[ select ] ][ old_group1 ] =  15  + rand()%6; 
				Tabutenure[ best_y[ select ] ][ old_group1 ] += iter ; 

				for(i=0;i<K;i++)
			      if(i != old_group)
			      {
			      	state2[i][old_group] = 0; 
				    state2[old_group][i] = 0;  
				  }
			    for(j=0;j<K;j++) 
			      if(j!=old_group1)
			      {
			      	 state2[j][old_group1] = 0; 
			      	 state2[old_group1][j] = 0; 
				  }
			}
			 
			iter ++ ;
			total_time = ( clock() - starting_time )/CLOCKS_PER_SEC ;
			if( f > f_best + 1.0e-10 )
			{
				if( f > f_best )
				{
					f_best = f;
					for( i = 0 ; i < N ; i ++ ) bestp[ i ] = S.p[ i ] ;
				//	printf("\n Swap_Move :  %8d       %5.6lf       %5.6lf       %5.3lf s", iter, f, f_best, total_time);
					non_improve = 0 ; 
				}  
				else if ( f == f_best )  non_improve++ ;
			}  
		   else  non_improve++ ;   
     }
      
    for(i=0;i<N;i++) S.p[i] = bestp[i];
    f = 0.0;
    for( i = 0 ; i < N ; i++ )  
	   for( j = i+1 ; j < N ; j++ )
	      {
	          if(S.p[i] == S.p[j])
               {   	
				  f += D[i][j];
	           }
	      }
    S.cost = f; 
    
    for(i=0;i<K;i++) S.SizeG[i] = 0; 
    for(i=0;i<N;i++) 
    {   
        g = S.p[i]; 
    	S.XG[g][S.SizeG[g]] = i; 
    	S.SizeG[g] ++ ; 
	}
    return S.cost;
}

/******************************************************************************************/
/*****************      9. Iterated Maxima Search Algorithm *******************************/
/******************************************************************************************/
void NDHA()
{     
     int i,j; 
     int k, k_min = 1 + 0.2*N/K, k_step = 1 + 0.2*N/K, k_max = 1 + 2.0*N/K; 
     double alpha = 0.01, r;

      
     GS.cost = -999999.0; 
     starting_time = clock(); 
     
     InitialSol(CS);
     for(i=0;i<N;i++) GS.p[i] = CS.p[i];
     for(j=0;j<K;j++) GS.SizeG[j] = CS.SizeG[j];
     for(i=0;i<K;i++)
       for(j=0;j<GS.SizeG[i]; j++) GS.XG[i][j] = CS.XG[i][j]; 
     GS.cost = CS.cost; 
     k = k_min; 
     while( 1.0*(clock()- starting_time)/CLOCKS_PER_SEC  <  Time_limit )
     {
        for(i=0;i<N;i++) NS.p[i] = CS.p[i]; 
        for(j=0;j<K;j++) NS.SizeG[j] = CS.SizeG[j]; 
        for(i=0;i<K;i++)
          for(j=0;j<NS.SizeG[i]; j++) NS.XG[i][j] = CS.XG[i][j]; 
        NS.cost = CS.cost; 
        Shake(NS,k); 
        LocalSearch(NS);  
        r = (double)(rand()% RAND_MAX)/RAND_MAX;
        if(r < beta*K/N) Swap_Move_Tabu_Search(NS);
        if( (1.0*NS.cost/CS.cost + alpha*distance(NS.p, CS.p) > 1.0) && (1.0*NS.cost/GS.cost + alpha*distance(NS.p, GS.p) > 1.0)  )
        {
           for(i=0;i<N;i++) CS.p[i] = NS.p[i]; 
           for(j=0;j<K;j++) CS.SizeG[j] = NS.SizeG[j]; 
           for(i=0;i<K;i++)
             for(j=0;j<CS.SizeG[i]; j++) CS.XG[i][j] = NS.XG[i][j]; 
           CS.cost = NS.cost;
           
           if(CS.cost > GS.cost) 
           {
             for(i=0;i<N;i++) GS.p[i] = CS.p[i]; 
             for(j=0;j<K;j++) GS.SizeG[j] = CS.SizeG[j]; 
             for(i=0;i<K;i++)
             for(j=0;j<GS.SizeG[i]; j++) GS.XG[i][j] = CS.XG[i][j]; 
             GS.cost = CS.cost; 
             // printf("f=%lf  k=%d  %lf \n",GS.cost,k, 1.0*(clock()- starting_time)/CLOCKS_PER_SEC );
             total_time = 1.0*(clock()- starting_time)/CLOCKS_PER_SEC ;
             k = k_min; 
           } 
           else
           {
			  k = k + k_step; 
              if(k > k_max) k = k_min;
           }   
        } 
        else
        {
           k = k + k_step; 
           if(k > k_max) k = k_min;
        }   
     }         
} 

/******************************************************************************************/
/********************    10. Main Function for Multiple Runs     **************************/
/******************************************************************************************/
int main(int argc, char *argv[])
{
    int i,j;
    int i1,j1;
    int seed; 
    const int  Times = 20; 
    double F[Times];
    double F_best= -99999999, F_worst = 999999999, F_ave = 0.0;
    seed = time(NULL) % 1000000 ;
	srand( seed );	
	
//    File_Name = "MDG-a_21_n2000_m200.txt";
//    Output_File_Name = "ss.txt";
//    Solution_File = "MDG-a_21_n2000_m200.sol";
//    Time_limit = 1200;
     
    File_Name = argv[1];
    Solution_File = argv[2];
    Output_File_Name = argv[3];
//	Time_limit = atoi(argv[4]); 
    Output_File_Name = "NDHA_result.txt";
     
    inputing();  
    AssignMemery(); 
    
    if(N==120) Time_limit = 3; 
    else if(N==240)Time_limit  = 20;
    else if(N==480)Time_limit  = 120; 
    else if(N==960)Time_limit  = 600; 
    else if(N==2000)Time_limit = 1200; 
    else if(N==3000)Time_limit = 3000; 

    OS.cost = -9999999.0; 
    for(j=0;j<Times;j++) F[j] = 0.0; 
    for(i=0; i < Times; i++)
    { 
	  seed = time(NULL) % 1000000 ;
	  srand( seed );
	  NDHA(); 
      if(Proof(GS)) 
      { 
        F[i] = GS.cost; 
        if(F[i]> OS.cost)
        {
            for(i1=0;i1<N;i1++) OS.p[i1] = GS.p[i1]; 
            for(j1=0;j1<K;j1++) OS.SizeG[j1] = GS.SizeG[j1]; 
            OS.cost = GS.cost;  
        }
      }
      printf("%lf  %lf\n",beta, F[i]);
    }
    for(i=0;i<Times;i++)   
    {
       if(F[i] > F_best )  F_best = F[i];    
       if(F[i] < F_worst)  F_worst = F[i];  
       F_ave += F[i];   
    }
    F_ave /=  Times; 
    Out_results(F_best , F_ave, F_worst, Output_File_Name, File_Name); 
    Outputing(OS, Solution_File);
    ReleaseMemery();
    return 0;
}
